/*
 * Accept.cpp
 *
 *  Created on: 9. 2. 2014
 *	  Author: Jan Travnicek
 */

#include "Accept.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace run {

auto AcceptDFALinearString = registration::AbstractRegister < Accept, bool, const automaton::DFA < > &, const string::LinearString < > & > ( Accept::accept );
auto AcceptNFALinearString = registration::AbstractRegister < Accept, bool, const automaton::NFA < > &, const string::LinearString < > & > ( Accept::accept );
auto AcceptDFTARankedTree = registration::AbstractRegister < Accept, bool, const automaton::DFTA < > &, const tree::RankedTree < > & > ( Accept::accept );
auto AcceptNFTARankedTree = registration::AbstractRegister < Accept, bool, const automaton::NFTA < > &, const tree::RankedTree < > & > ( Accept::accept );
auto AcceptInputDrivenDPDALinearString = registration::AbstractRegister < Accept, bool, const automaton::InputDrivenDPDA < > &, const string::LinearString < > & > ( Accept::accept );
auto AcceptVisiblyPushdownDPDALinearString = registration::AbstractRegister < Accept, bool, const automaton::VisiblyPushdownDPDA < > &, const string::LinearString < > & > ( Accept::accept );
auto AcceptRealTimeHeightDeterministicDPDALinearString = registration::AbstractRegister < Accept, bool, const automaton::RealTimeHeightDeterministicDPDA < > &, const string::LinearString < > & > ( Accept::accept );
auto AcceptDPDALinearString = registration::AbstractRegister < Accept, bool, const automaton::DPDA < > &, const string::LinearString < > & > ( Accept::accept );
auto AcceptNPDTALinearString = registration::AbstractRegister < Accept, bool, const automaton::NPDTA < > &, const string::LinearString < > & > ( Accept::accept );

} /* namespace run */

} /* namespace automaton */
