/*
 * Dijkstra.h
 *
 *   Created on: Jun 19, 2014
 *       Author: David Rosca
 */

#ifndef GRAPH_DIJKSTRA_H_
#define GRAPH_DIJKSTRA_H_

#include <unordered_map>

#include <graph/GraphClasses.h>

namespace graph {

namespace shortestpath {

// Dijkstra only works on graphs without negative-weight edges (>= 0)

class Dijkstra {
public:
	typedef ext::unordered_map<Node, int> Result;

	static Result dijkstra(const DirectedGraph &graph, const Node &start);
	static Result dijkstra(const UndirectedGraph &graph, const Node &start);
};

} // namespace shortestpath

} // namespace graph

#endif // GRAPH_DIJKSTRA_H_
