/*
 * AutomatonDiff.cpp
 *
 *  Created on: Apr 1, 2013
 *      Author: martin
 */

#include "AutomatonDiff.h"
#include <registration/AlgoRegistration.hpp>

namespace compare {

auto AutomatonDiffDFA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::DFA < > &, const automaton::DFA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffNFA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::NFA < > & , const automaton::NFA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffMultiInitialStateNFA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::MultiInitialStateNFA < > &, const automaton::MultiInitialStateNFA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffEpsilonNFA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::EpsilonNFA < > &, const automaton::EpsilonNFA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffExtendedNFA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::ExtendedNFA < > &, const automaton::ExtendedNFA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffCompactNFA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::CompactNFA < > &, const automaton::CompactNFA < > & > ( AutomatonDiff::diff );

auto AutomatonDiffDFTA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::DFTA < > &, const automaton::DFTA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffNFTA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::NFTA < > &, const automaton::NFTA < > & > ( AutomatonDiff::diff );

auto AutomatonDiffDPDA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::DPDA < > &, const automaton::DPDA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffNPDA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::NPDA < > &, const automaton::NPDA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffInputDrivenDPDA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::InputDrivenDPDA < > &, const automaton::InputDrivenDPDA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffInputDrivenNPDA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::InputDrivenNPDA < > &, const automaton::InputDrivenNPDA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffVisiblyPushdownDPDA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::VisiblyPushdownDPDA < > &, const automaton::VisiblyPushdownDPDA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffVisiblyPushdownNPDA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::VisiblyPushdownNPDA < > &, const automaton::VisiblyPushdownNPDA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffRealTimeHeightDeterministicDPDA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::RealTimeHeightDeterministicDPDA < > &, const automaton::RealTimeHeightDeterministicDPDA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffRealTimeHeightDeterministicNPDA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::RealTimeHeightDeterministicNPDA < > &, const automaton::RealTimeHeightDeterministicNPDA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffSinglePopDPDA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::SinglePopDPDA < > &, const automaton::SinglePopDPDA < > & > ( AutomatonDiff::diff );
auto AutomatonDiffSinglePopNPDA = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::SinglePopNPDA < > &, const automaton::SinglePopNPDA < > & > ( AutomatonDiff::diff );

auto AutomatonDiffOneTapeDTM = registration::AbstractRegister < AutomatonDiff, std::string, const automaton::OneTapeDTM < > &, const automaton::OneTapeDTM < > & > ( AutomatonDiff::diff );

} /* namespace compare */
