/*
 * Symbol.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "Symbol.h"
#include "LabeledSymbol.h"
#include "label/Label.h"

namespace alphabet {

void Symbol::inc ( ) {
	this->operator ++ ( );
}

Symbol::Symbol ( const label::Label & label ) : alib::WrapperBase < SymbolBase > ( alphabet::LabeledSymbol { label } ) {
}

Symbol::Symbol ( label::Label && label ) : alib::WrapperBase < SymbolBase > ( alphabet::LabeledSymbol { std::move ( label ) } ) {
}

Symbol::Symbol ( int number ) : Symbol ( label::Label ( number ) ) {
}

Symbol::Symbol ( char character ) : Symbol ( label::Label ( character ) ) {
}

Symbol::Symbol ( std::string string ) : Symbol ( label::Label ( std::move ( string ) ) ) {
}

Symbol::Symbol ( const char * string ) : Symbol ( ( std::string ) string ) {
}

} /* namespace alphabet */
