/*
 * VariablesBarSymbol.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "VariablesBarSymbol.h"
#include "Symbol.h"
#include <object/Object.h>
#include "UniqueSymbol.h"

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

VariablesBarSymbol::VariablesBarSymbol ( ) {
}

SymbolBase * VariablesBarSymbol::clone ( ) const {
	return new VariablesBarSymbol ( * this );
}

SymbolBase * VariablesBarSymbol::plunder ( ) && {
	return new VariablesBarSymbol ( std::move ( * this ) );
}

int VariablesBarSymbol::compare ( const VariablesBarSymbol & ) const {
	return 0;
}

void VariablesBarSymbol::operator >>( std::ostream & out ) const {
	out << "(Variables bar symbol)";
}

VariablesBarSymbol::operator std::string ( ) const {
	return VariablesBarSymbol::instance < std::string > ( );
}

SymbolBase * VariablesBarSymbol::inc ( ) && {
	return new UniqueSymbol ( Symbol ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::VariablesBarSymbol > ( );

} /* namespace */
