/*
 * BarSymbol.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Stepan Plachy
 */

#include "BarSymbol.h"
#include <alphabet/Symbol.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace alib {

alphabet::BarSymbol xmlApi < alphabet::BarSymbol >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return alphabet::BarSymbol ( );
}

bool xmlApi < alphabet::BarSymbol >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < alphabet::BarSymbol >::xmlTagName ( ) {
	static std::string xmlTagName = "BarSymbol";

	return xmlTagName;
}

void xmlApi < alphabet::BarSymbol >::compose ( ext::deque < sax::Token > & output, const alphabet::BarSymbol & ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace alib */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < alphabet::Symbol, alphabet::BarSymbol > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < alib::Object, alphabet::BarSymbol > ( );

static auto xmlReader = registration::XmlReaderRegister < alphabet::Symbol, alphabet::BarSymbol > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < alib::Object, alphabet::BarSymbol > ( );

} /* namespace */
