/*
 * InitialSymbol.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "InitialSymbol.h"
#include <alphabet/Symbol.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace alib {

alphabet::InitialSymbol xmlApi < alphabet::InitialSymbol >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return alphabet::InitialSymbol ( );
}

bool xmlApi < alphabet::InitialSymbol >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < alphabet::InitialSymbol >::xmlTagName ( ) {
	static std::string xmlTagName = "InitialSymbol";

	return xmlTagName;
}

void xmlApi < alphabet::InitialSymbol >::compose ( ext::deque < sax::Token > & output, const alphabet::InitialSymbol & ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace alib */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < alphabet::Symbol, alphabet::InitialSymbol > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < alib::Object, alphabet::InitialSymbol > ( );

static auto xmlReader = registration::XmlReaderRegister < alphabet::Symbol, alphabet::InitialSymbol > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < alib::Object, alphabet::InitialSymbol > ( );

} /* namespace */
