/*
 * CompactNFA.cpp
 *
 *  Created on: Mar 25, 2013
 *      Author: Jan Travnicek
 */

#include "CompactNFA.h"
#include <automaton/Automaton.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/ComponentRegistration.hpp>

namespace {

static auto components = registration::ComponentRegister < automaton::CompactNFA < > > ( );

static auto valuePrinter = registration::ValuePrinterRegister < automaton::CompactNFA < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < automaton::Automaton, automaton::CompactNFA < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < alib::Object, automaton::CompactNFA < > > ( );

static auto xmlReader = registration::XmlReaderRegister < automaton::Automaton, automaton::CompactNFA < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < alib::Object, automaton::CompactNFA < > > ( );

static auto compactNFAFromDFA = registration::CastRegister < automaton::CompactNFA < >, automaton::DFA < > > ( );
static auto compactNFAFromNFA = registration::CastRegister < automaton::CompactNFA < >, automaton::NFA < > > ( );
static auto compactNFAFromMultiInitialStateNFA = registration::CastRegister < automaton::CompactNFA < >, automaton::MultiInitialStateNFA < > > ( );
static auto compactNFAEpsilonNFA = registration::CastRegister < automaton::CompactNFA < >, automaton::EpsilonNFA < > > ( );

} /* namespace */
