/*
 * PrefixRankedBarNonlinearPattern.cpp
 *
 *  Created on: Jul 20, 2016
 *      Author: Jan Travnicek
 */

#include "PrefixRankedBarNonlinearPattern.h"
#include <tree/Tree.h>
#include <tree/RankedTreeWrapper.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/ComponentRegistration.hpp>

namespace {

static auto components = registration::ComponentRegister < tree::PrefixRankedBarNonlinearPattern < > > ( );

static auto valuePrinter = registration::ValuePrinterRegister < tree::PrefixRankedBarNonlinearPattern < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < tree::Tree, tree::PrefixRankedBarNonlinearPattern < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < tree::RankedTreeWrapper, tree::PrefixRankedBarNonlinearPattern < > > ( );
static auto xmlWrite3 = registration::XmlWriterRegister < alib::Object, tree::PrefixRankedBarNonlinearPattern < > > ( );

static auto xmlReader = registration::XmlReaderRegister < tree::Tree, tree::PrefixRankedBarNonlinearPattern < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < tree::RankedTreeWrapper, tree::PrefixRankedBarNonlinearPattern < > > ( );
static auto xmlReaded3 = registration::XmlReaderRegister < alib::Object, tree::PrefixRankedBarNonlinearPattern < > > ( );

static auto PrefixRankedBarNonlinearPatternFromRankedTree = registration::CastRegister < tree::PrefixRankedBarNonlinearPattern < >, tree::RankedTree < > > ( );
static auto PrefixRankedBarNonlinearPatternFromRankedPattern = registration::CastRegister < tree::PrefixRankedBarNonlinearPattern < >, tree::RankedPattern < > > ( );
static auto PrefixRankedBarNonlinearPatternFromRankedNonlinearPattern = registration::CastRegister < tree::PrefixRankedBarNonlinearPattern < >, tree::RankedNonlinearPattern < > > ( );
static auto PrefixRankedBarNonlinearPatternFromPrefixRankedBarTree = registration::CastRegister < tree::PrefixRankedBarNonlinearPattern < >, tree::PrefixRankedBarTree < > > ( );
static auto PrefixRankedBarNonlinearPatternFromPrefixRankedBarPattern = registration::CastRegister < tree::PrefixRankedBarNonlinearPattern < >, tree::PrefixRankedBarPattern < > > ( );

} /* namespace */
