/*
 * PrefixRankedTree.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrefixRankedTree.h"
#include <tree/Tree.h>
#include <tree/RankedTreeWrapper.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/ComponentRegistration.hpp>

namespace {

static auto components = registration::ComponentRegister < tree::PrefixRankedTree < > > ( );

static auto valuePrinter = registration::ValuePrinterRegister < tree::PrefixRankedTree < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < tree::Tree, tree::PrefixRankedTree < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < tree::RankedTreeWrapper, tree::PrefixRankedTree < > > ( );
static auto xmlWrite3 = registration::XmlWriterRegister < alib::Object, tree::PrefixRankedTree < > > ( );

static auto xmlReader = registration::XmlReaderRegister < tree::Tree, tree::PrefixRankedTree < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < tree::RankedTreeWrapper, tree::PrefixRankedTree < > > ( );
static auto xmlReaded3 = registration::XmlReaderRegister < alib::Object, tree::PrefixRankedTree < > > ( );

static auto PrefixRankedTreeFromRankedTree = registration::CastRegister < tree::PrefixRankedTree < >, tree::RankedTree < > > ( );

} /* namespace */
