/*
 * UnrankedTree.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Stepan Plachy
 */

#include "UnrankedTree.h"
#include <tree/Tree.h>
#include <tree/UnrankedTreeWrapper.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/ComponentRegistration.hpp>

namespace {

static auto components = registration::ComponentRegister < tree::UnrankedTree < > > ( );

static auto valuePrinter = registration::ValuePrinterRegister < tree::UnrankedTree < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < tree::Tree, tree::UnrankedTree < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < tree::UnrankedTreeWrapper, tree::UnrankedTree < > > ( );
static auto xmlWrite3 = registration::XmlWriterRegister < alib::Object, tree::UnrankedTree < > > ( );

static auto xmlReader = registration::XmlReaderRegister < tree::Tree, tree::UnrankedTree < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < tree::UnrankedTreeWrapper, tree::UnrankedTree < > > ( );
static auto xmlReaded3 = registration::XmlReaderRegister < alib::Object, tree::UnrankedTree < > > ( );

static auto UnrankedTreeFromRankedTree = registration::CastRegister < tree::UnrankedTree < >, tree::RankedTree < > > ( );

} /* namespace */
