/*
 * typeinfo.cpp
 *
 * Created on: Oct 19, 2017
 * Author: Jan Travnicek
 */

#include <typeinfo>
#include <algorithm>

namespace ext {

std::string erase_template_info ( std::string str ) {
	for ( ; ; ) {
		std::pair < std::string::iterator, std::string::iterator > range = ext::find_range ( str.begin ( ), str.end ( ), '<', '>' );

		if ( range.first == range.second )
			break;

		str.erase ( range.first, range.second );
	}
	return str;
}

bool is_same_type ( const std::string & first, const std::string & second ) {
	ext::vector < std::string > explodedFirst = ext::explode ( first, "::" );
	ext::vector < std::string > explodedSecond = ext::explode ( second, "::" );

	if ( explodedFirst.size ( ) > explodedSecond.size ( ) )
		return false;

	unsigned offset = explodedSecond.size ( ) - explodedFirst.size ( );

	for ( unsigned index = 0; index < explodedFirst.size ( ); ++ index ) {
		if ( explodedFirst [ index ] == "" )
			continue;

		if ( explodedFirst [ index ] != explodedSecond [ index + offset ] )
			return false;
	}

	return true;
}

} /* namespace ext */
