/*
 * typeinfo.hpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef __TYPEINFO_HPP_
#define __TYPEINFO_HPP_

#include <typeinfo>
#include <typeindex>
#include <string>

#include "string.hpp"
#include "typeindex.h"

namespace ext {

template < class T, typename std::enable_if < std::is_class < T >::value >::type * = nullptr >
std::string to_string ( ) {
	std::string res = ext::to_string ( ext::type_index ( typeid ( T * ) ) ); // handle even incomplete class types
	res.pop_back ( ); // to erase extra pointer
	return res;
}

template < class T, typename std::enable_if < ! std::is_class < T >::value >::type * = nullptr >
std::string to_string ( ) {
	return ext::to_string ( ext::type_index ( typeid ( T ) ) );
}

bool is_same_type ( const std::string & first, const std::string & second );

template < typename T >
bool is_same_type ( const std::string & name ) {
	std::string ret = to_string < T > ( );
	return is_same_type ( ret, name );
}

std::string erase_template_info ( std::string str );

} /* namespace ext */

#endif /* __TYPEINFO_HPP_ */
