#ifndef SET_TEST_H_
#define SET_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

class SetTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( SetTest );
  CPPUNIT_TEST( test1 );
  CPPUNIT_TEST( test2 );
  CPPUNIT_TEST( test3 );
  CPPUNIT_TEST( test4 );
  CPPUNIT_TEST_SUITE_END();

public:
class Moveable {
	int& m_moves;
	int& m_copies;

public:
	Moveable(int& moves, int& copies) : m_moves(moves), m_copies(copies) {
		m_moves = 0;
		m_copies = 0;
	}

	Moveable(const Moveable& src) : m_moves(src.m_moves), m_copies(src.m_copies) {
		m_copies++;
	}

	Moveable(Moveable&& src) : m_moves(src.m_moves), m_copies(src.m_copies) {
		m_moves++;
	}

	bool operator<(const Moveable&) const {
		return false;
	}
};

public:
  void setUp();
  void tearDown();

  void test1();
  void test2();
  void test3();
  void test4();
};

#endif  // SET_TEST_H_
