#include "TypeTraitsTest.h"
#include <type_traits>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( TypeTraitsTest, "bits" );
CPPUNIT_TEST_SUITE_REGISTRATION( TypeTraitsTest );

void TypeTraitsTest::setUp() {
}

void TypeTraitsTest::tearDown() {
}

void TypeTraitsTest::testAccessPackElement() {
	CPPUNIT_ASSERT( ( std::is_same< ext::get_type_pack_element < 0, int, double >::type, int >::value ) == true );
}

void TypeTraitsTest::testTypeInPack() {
	CPPUNIT_ASSERT( ( ext::is_in< int, double, ext::set<int>, float, char, int, std::string >::value ) == true );
	CPPUNIT_ASSERT( ( ext::is_in< long, double, ext::set<int>, float, char, int, std::string >::value ) == false );

	CPPUNIT_ASSERT( ( ext::is_in< std::pair < int, int >, void, ext::pair < int, int > >::value ) == false );
}

class Foo {
};

class Bar;

void TypeTraitsTest::testTypeNames() {
	CPPUNIT_ASSERT ( ext::to_string < Foo > ( ) == "Foo" );
	CPPUNIT_ASSERT ( ext::to_string < Bar > ( ) == "Bar" );
	CPPUNIT_ASSERT ( ext::to_string < int > ( ) == "int" );
}
