/*
 * BottomOfTheStackSymbol.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "BottomOfTheStackSymbol.h"
#include <alphabet/BottomOfTheStackSymbol.h>
#include <object/Object.h>
#include <alphabet/Symbol.h>

#include <registration/StringRegistration.hpp>

namespace alib {

alphabet::BottomOfTheStackSymbol stringApi < alphabet::BottomOfTheStackSymbol >::parse ( std::istream & ) {
	throw exception::CommonException("parsing BottomOfTheStackSymbol from string not implemented");
}

bool stringApi < alphabet::BottomOfTheStackSymbol >::first ( std::istream & ) {
	return false;
}

void stringApi < alphabet::BottomOfTheStackSymbol >::compose ( std::ostream & output, const alphabet::BottomOfTheStackSymbol & ) {
	output << "#T";
}

} /* namespace alib */

namespace {

static auto stringWrite = registration::StringWriterRegister < alphabet::Symbol, alphabet::BottomOfTheStackSymbol > ( );
static auto stringWrite2 = registration::StringWriterRegister < alib::Object, alphabet::BottomOfTheStackSymbol > ( );

} /* namespace */
