/*
 * InitialSymbol.cpp
 *
 * Created on: Nov 21, 2017
 * Author: Tomas Pecka
 */

#include "InitialSymbol.h"
#include <alphabet/InitialSymbol.h>
#include <alphabet/Symbol.h>
#include <object/Object.h>

#include <registration/StringRegistration.hpp>

namespace alib {

alphabet::InitialSymbol stringApi < alphabet::InitialSymbol >::parse ( std::istream & ) {
	throw exception::CommonException ( "parsing InitialSymbol from string not implemented" );
}

bool stringApi < alphabet::InitialSymbol >::first ( std::istream & ) {
	return false;
}

void stringApi < alphabet::InitialSymbol >::compose ( std::ostream & output, const alphabet::InitialSymbol & ) {
	output << "#I";
}

} /* namespace alib */

namespace {

static auto stringWrite = registration::StringWriterRegister < alphabet::Symbol, alphabet::InitialSymbol > ( );
static auto stringWrite2 = registration::StringWriterRegister < alib::Object, alphabet::InitialSymbol > ( );

} /* namespace */
