/*
 * CNF.h
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#ifndef _STRING_CNF_H_
#define _STRING_CNF_H_

#include <grammar/ContextFree/CNF.h>
#include <core/stringApi.hpp>

#include <grammar/GrammarFromStringLexer.h>

#include <grammar/string/common/GrammarFromStringParserCommon.h>
#include <grammar/string/common/GrammarToStringComposerCommon.h>

namespace alib {

template<class SymbolType >
struct stringApi < grammar::CNF < SymbolType > > {
	static grammar::CNF < SymbolType > parse ( std::istream & input );
	static bool first ( std::istream & input );
	static void compose ( std::ostream & output, const grammar::CNF < SymbolType > & grammar );
};

template<class SymbolType >
grammar::CNF < SymbolType > stringApi < grammar::CNF < SymbolType > >::parse ( std::istream & input ) {
	grammar::GrammarFromStringLexer::Token token = grammar::GrammarFromStringLexer::next(input);
	if(token.type != grammar::GrammarFromStringLexer::TokenType::CNF)
		throw exception::CommonException("Unrecognised CNF token.");

	return grammar::GrammarFromStringParserCommon::parseCFLikeGrammar < grammar::CNF < SymbolType > > ( input );
}

template<class SymbolType >
bool stringApi < grammar::CNF < SymbolType > >::first ( std::istream & input ) {
	grammar::GrammarFromStringLexer::Token token = grammar::GrammarFromStringLexer::next ( input );
	bool res = token.type == grammar::GrammarFromStringLexer::TokenType::CNF;
	grammar::GrammarFromStringLexer::putback ( input, token );
	return res;
}

template<class SymbolType >
void stringApi < grammar::CNF < SymbolType > >::compose ( std::ostream & output, const grammar::CNF < SymbolType > & grammar ) {
	output << "CNF";
	grammar::GrammarToStringComposerCommon::composeCFLikeGrammar ( output, grammar );
}

} /* namespace alib */

#endif /* _STRING_CNF_H_ */
