/*
 * HexavigesimalLabel.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "HexavigesimalLabel.h"
#include <label/HexavigesimalLabel.h>
#include <primitive/string/String.h>
#include <object/Object.h>
#include <label/Label.h>

#include <registration/StringRegistration.hpp>

namespace alib {

label::HexavigesimalLabel stringApi < label::HexavigesimalLabel >::parse ( std::istream & ) {
	throw exception::CommonException("parsing HexavigesimalLabel from string not implemented");
}

bool stringApi < label::HexavigesimalLabel >::first ( std::istream & ) {
	return false;
}

void stringApi < label::HexavigesimalLabel >::compose ( std::ostream & output, const label::HexavigesimalLabel & label ) {
	stringApi < std::string >::compose ( output, (std::string) label );
}

} /* namespace alib */

namespace {

static auto stringWrite = registration::StringWriterRegister < label::Label, label::HexavigesimalLabel > ( );
static auto stringWrite2 = registration::StringWriterRegister < alib::Object, label::HexavigesimalLabel > ( );

} /* namespace */
