/*
 * Character.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "Character.h"
#include <primitive/Primitive.h>
#include <object/Object.h>

#include <registration/StringRegistration.hpp>

namespace alib {

char stringApi < char >::parse ( std::istream & ) {
	throw exception::CommonException("parsing char from string not implemented");
}

bool stringApi < char >::first ( std::istream & ) {
	return false;
}

void stringApi < char >::compose ( std::ostream & output, char primitive ) {
	output << primitive;
}

primitive::Character stringApi < primitive::Character >::parse ( std::istream & input ) {
	return primitive::Character ( stringApi < char >::parse ( input ) );
}

bool stringApi < primitive::Character >::first ( std::istream & input ) {
	return stringApi < char >::first ( input );
}

void stringApi < primitive::Character >::compose ( std::ostream & output, const primitive::Character & primitive ) {
	stringApi < char >::compose ( output, primitive.getData ( ) );
}

} /* namespace alib */

namespace {

static auto stringWrite = registration::StringWriterRegister < primitive::Primitive, primitive::Character > ( );
static auto stringWrite2 = registration::StringWriterRegister < alib::Object, primitive::Character > ( );

} /* namespace */
