/*
 * String.h
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#ifndef _STRING_STRING_H_
#define _STRING_STRING_H_

#include <primitive/String.h>
#include <core/stringApi.hpp>

#include <primitive/PrimitiveFromStringLexer.h>

namespace alib {

template < >
struct stringApi < std::string > {
	static std::string parse ( std::istream & input );
	static bool first ( std::istream & input );
	static void compose ( std::ostream & output, const std::string & primitive );
};

template < >
struct stringApi < primitive::String > {
	static primitive::String parse ( std::istream & input );
	static bool first ( std::istream & input );
	static void compose ( std::ostream & output, const primitive::String & primitive );
};

} /* namespace alib */

#endif /* _STRING_STRING_H_ */
