/*
 * Integer.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef _XML_PRIMITIVE_INTEGER_H_
#define _XML_PRIMITIVE_INTEGER_H_

#include <primitive/Integer.h>
#include <core/xmlApi.hpp>

namespace alib {

template < >
struct xmlApi < int > {
	static int parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, int data );
};

template < >
struct xmlApi < primitive::Integer > {
	static primitive::Integer parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, const primitive::Integer & data );
};

} /* namespace alib */

#endif /* _XML_PRIMITIVE_INTEGER_H_ */
