/*
 * XmlParserRegistry.cpp
 *
 *  Created on: 21. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <registry/XmlParserRegistry.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > XmlParserRegistry::getAbstraction ( const std::string & typeName ) {
	auto type = getEntries ( ).find ( typeName );
	if ( type == getEntries ( ).end ( ) )
		throw exception::CommonException ( "Entry " + typeName + " not available." );

	return type->second->getAbstraction ( );
}

} /* namespace abstraction */
