#include "AnyObjectTest.h"

#include <object/xml/AnyObject.h>
#include <container/xml/ObjectsPair.h>
#include <primitive/xml/Character.h>
#include <primitive/xml/Integer.h>

#include <factory/XmlDataFactory.hpp>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( AnyObjectTest, "object" );
CPPUNIT_TEST_SUITE_REGISTRATION ( AnyObjectTest );

void AnyObjectTest::setUp ( ) {
}

void AnyObjectTest::tearDown ( ) {
}

void AnyObjectTest::testXMLParser ( ) {

	alib::AnyObject < ext::pair < int, char > > object ( ext::make_pair ( 1, 'a' ) );
	alib::Object res ( container::ObjectsPair < alib::Object, alib::Object > ( alib::Object ( primitive::Integer ( 1 ) ), alib::Object ( primitive::Character ( 'a' ) ) ) );

	{
		std::string tmp = alib::XmlDataFactory::toString ( object );
		alib::Object object2 = alib::XmlDataFactory::fromString ( tmp );

		CPPUNIT_ASSERT ( res == object2 );
	}
}

